#include<iostream>
#include<vector>
#include<utility>
#include<algorithm>
#include<ctime>
#include<map>
#include<sstream>
#include<fstream>
using namespace std;
#define MAX 1000000
struct edge
{
    int s,e,w;
};

int parent(int k, vector<int>& p)
{
   if(k==p[k])
   return k;
   p[k]=parent(p[k],p);
   return p[k]; 
}

vector<int> p;

int boruvka(vector<vector<pair<int,int> > > &v,int n)
{
    int i,j,min,sum=0,a,b,cnt;
    edge ed,ed1;
    cnt=0;
    bool finished = true;
    for(i = 0; i < n; i++)
    {  
      p[i] = i;
    }
    for(i=0;i<n;i++)
    { 
      if(!v[i].empty())
      {
        min=v[i][0].second;
        b = v[i][0].first;
        a = i;
        for(j=1;j<v[i].size();j++)
        {
           if(min > v[i][j].second || (min == v[i][j].second && v[i][j].first < b))
            {
              min = v[i][j].second;
              b = v[i][j].first;
            }
        }
        auto p_a = parent(a, p);
        auto p_b = parent(b, p);
        if(p_a != p_b)
        {
            finished = false;
            edge e;
            e.s = a;
            e.e = b;
            e.w = min;
            sum += min;
            if(p_a < p_b) 
            {
              p[p_b] = p_a;
            }
            else
            {
              p[p_a] = p[p_b];
            }
        }
      }
    }
    if(finished)
    {
      return 0;
    }
    map<int, int> comp;
    for(i=0;i<n;i++)
    {
      p[i]=parent(i,p);
      if(comp.find(p[i]) == comp.end() && !v[i].empty())
      {
        comp[p[i]] = comp.size();
      }
    }

    vector<vector<pair<int,int> > > vec(comp.size());
     for(i=0;i<n;i++)
     {
        for(j=0; j < v[i].size();j++)
        {
          auto p_a = p[i];
          auto p_b = p[v[i][j].first];
          if(p_a != p_b)
          {
             vec[comp[p_a]].push_back(make_pair(comp[p_b],v[i][j].second));
          }
        }
     }

     return sum + boruvka(vec, vec.size());
}
int main()
{
  vector<vector<pair<int,int > > > vec(MAX);
   int mst;
    edge e1;
    int i,v,edg;
string namefile, line;
    int counter = 0,b=0,l=0,h=0,cnt=0;   
    ifstream file("data.csv");
     string s,e,w,d;
    if( !file.is_open()) {

        cout << "File "<< namefile <<" not found." << endl;
        exit(-1);

    }
     while ( getline( file, line) ) { // To get the number of lines in the file
        counter++;
    }
    file.close();
    ifstream file1("data.csv");
    i=0;
    map<int, int> mp;
    while(file1.good() && cnt!=(counter))
    {  
        edge e1;
        getline(file1,s,',');
        stringstream geek(s);
        geek >> b;
        if(mp.find(b) != mp.end())
        {
            b = mp[b];
        }
        else
        {
            int val = mp.size();
            
            mp[b] = val;
            b = val;
        }
        e1.s=b;
        getline(file1,e,',');
        stringstream geek1(e);
        geek1>> l;
        if(mp.find(l) != mp.end())
        {
            l = mp[l];
        }
        else
        {
            int val = mp.size();
            mp[l] = val;
            l = val;
        }
        e1.e=l;
        getline(file1,w,',');
        stringstream geek2(w);
        geek2>> h;
        e1.w=h;
        vec[e1.s].push_back(make_pair(e1.e,e1.w));
        vec[e1.e].push_back(make_pair(e1.s,e1.w));
        getline(file1,d,'\n');
        cnt++;
        
    }
     file1.close();
     edg=cnt; 
     v=mp.size();
     p.resize(v);
     clock_t t;
    t = clock();
    mst=boruvka(vec,v);
    cout<<"MST : "<<mst<<endl;
    t = clock() - t;
    double time_taken = ((double)t)/CLOCKS_PER_SEC; // in seconds
    cout<<"boruvka() took "<<time_taken<<" seconds to execute \n";
}
