#include<iostream>
#include<vector>
#include<ctime>
#include<sstream>
#include<fstream>
#include<algorithm>
# include <map>
using namespace std;
#define max 50000
struct edge
{
     int s,e,w;
};
struct compare
{
  inline bool operator() (edge const &a,edge const &b)
  {
    return (a.w > b.w);
  }
};
int find(int a,int* p,int flag,int t)
{
     
    if(p[a]==a)
    return a;
    p[a] = find(p[a],p,flag,t);

    return p[a];
}
void Union(int x,int y,int* p)
{
    p[y]=x;

}
vector<edge> kruskals(int *p,int vert,vector<edge>& v,int edges)
{   
     int sum=0,flag=0,x,y,i;
     
     vector<edge> mst;
     
    sort(v.begin(),v.end(),compare());
   
     while(mst.size()!=vert-1 && !v.empty())
     {
       edge ed= v.back();
       v.pop_back();
       
       
       x=find(ed.s,p,flag,ed.s);
       y=find(ed.e,p,flag,ed.e);
       
      if(x!=y)
      {  
          mst.push_back(ed);
         sum=sum+ed.w;
         flag++;
          Union(x,y,p);   
      }      
    }
    cout<<"weight of MST: "<<sum<<endl;
     return mst; 
}

int main()
{
    int vert,edges,i,j,flag=0;
    int* p=new int[max];
    vector<edge> vec;
    edge e1;
    string namefile, line;
    int counter = 0,b=0,l=0,h=0,cnt=0;   
    ifstream file("data.csv");
     string s,e,w,d;
    if( !file.is_open()) {

        cout << "File "<< namefile <<" not found." << endl;
        exit(-1);

    }
     while ( getline( file, line) ) { // To get the number of lines in the file
        counter++;
    }
    file.close();
    ifstream file1("data.csv");
    i=0;
    map<int, int> mp;
    vector<edge> v;
    file1.seekg(0);
    while(!file1.eof() && cnt!=counter)
    {  
        edge ed;
        getline(file1,s,',');
        stringstream geek(s);
        geek >> b;
        if(mp.find(b) != mp.end())
        {
            b = mp[b];
        }
        else
        {
            int val = mp.size();
            
            mp[b] = val;
            b = val;
        }
        ed.s=b;
        getline(file1,e,',');
        stringstream geek1(e);
        geek1>> l;
        if(mp.find(l) != mp.end())
        {
            l = mp[l];
        }
        else
        {
            int val = mp.size();
            mp[l] = val;
            l = val;
        }
        ed.e=l;
        getline(file1,w,',');
        stringstream geek2(w);
        geek2>> h;
        ed.w=h;
        v.push_back(ed);
        getline(file1,d,'\n');
        cnt++;        
    }
    file1.close();
    for(i=0;i<mp.size();i++)
      p[i]=i;
    vert=mp.size();
    i=cnt;
    clock_t t;
    t = clock();
   vec=kruskals(p,vert,v,i);
   delete [] p;
   t = clock() - t;
    double time_taken = ((double)t)/CLOCKS_PER_SEC; // in seconds
 
    cout<<"kruskals() took "<<time_taken<<" seconds to execute \n";
}
