#include<iostream>
#include<vector>
#include<utility>
#include<queue>
#include<fstream>
#include<map>
#include<sstream>
#include<ctime>
using namespace std;
#define MAX 700000
struct edge
{
    int s,e,w;
};
struct comp
{
  bool operator()(const edge& l, const edge& r)
  {
      return l.w > r.w;
  }
};
edge add_edge(edge ed,priority_queue<edge,vector<edge>,comp> &pq,vector<int>& k, int& found)
{
  if(pq.size() == 0)
  {
    edge e;
    found = 0;
    return e;
  }
  if(k[ed.s]!=1 || k[ed.e]!=1)
  {
    found = 1;
    return ed;
  }
  else
  {
    pq.pop();
    ed=pq.top();
    return add_edge(ed,pq,k,found);
  }
}
int sum=0;
int f=0;
void prims(vector<vector<pair<int,int > > > &vec,int v, vector<int>& vis)
{
  
  priority_queue<edge,vector<edge>,comp> pq;
  vector<edge> mst;
  int i,flag=0;
  int l=v;
  while(true)
  {
    vis[l]=1;
    for(i=0;i<vec[l].size();i++)
    {
      edge ed;
      ed.s=l;
      ed.e=vec[l][i].first;
      ed.w=vec[l][i].second;
      if(vis[ed.e]==0)
      pq.push(ed);
    }
    if(pq.size() == 0)
    {
      break;
    }
    edge e1;
    e1=pq.top();
    int found = 0;
    e1=add_edge(e1,pq,vis, found);
    if(found == 1)
    {
   
      mst.push_back(e1);
      pq.pop();
      l=e1.e;
    }
    else
    {
      break;
    }
  }
  for (edge &edg: mst){
    sum=sum+edg.w;
    f++;
  }
  
}

void concomp(vector<vector<pair<int,int> > >&vec)
{
    vector<int> vis(vec.size());
    int i;
    for(i=0;i<vec.size();i++)
    vis[i]=0;
    for(i=0;i<vec.size();i++)
    {
      if(vis[i]==0)
        prims(vec, i, vis);
    }
}

int main()
{
    int v,ed,i;
    vector<vector<pair<int,int> > > vec;
   string namefile, line;
    int counter = 0,b=0,l=0,h=0,cnt=0;   
    ifstream file("data4.txt");
     string s,e,w,d;
    if( !file.is_open()) {

        cout << "File "<< namefile <<" not found." << endl;
        exit(-1);

    }
     while ( getline( file, line) ) { // To get the number of lines in the file
        counter++;
    }
    file.close();
    ifstream file1("data4.txt");
    i=0;
    map<int, int> mp;
    vector<pair<int,int> > vl;
    while(file1.good() && cnt!=(counter))
    {  
        edge e1;
        getline(file1,s,' ');
        stringstream geek(s);
        geek >> b;
        if(mp.find(b) != mp.end())
        {
            b = mp[b];
            vec.push_back(vl);
        }
        else
        {
            int val = mp.size();
            
            mp[b] = val;
            b = val;
            vec.push_back(vl);
        }
        e1.s=b;
        getline(file1,e,' ');
        stringstream geek1(e);
        geek1>> l;
        if(mp.find(l) != mp.end())
        {
            l = mp[l];
            vec.push_back(vl);
        }
        else
        {
            int val = mp.size();
            mp[l] = val;
            l = val;
            vec.push_back(vl);
        }
        e1.e=l;
        getline(file1,w,'\n');
        stringstream geek2(w);
        geek2>> h;
        e1.w=h;
        vec[e1.s].push_back(make_pair(e1.e,e1.w));
        vec[e1.e].push_back(make_pair(e1.s,e1.w));
       // getline(file1,d,'\n');
        cnt++;
        
    }
     file1.close();
      clock_t t;
    t = clock();
    concomp(vec);
    t = clock() - t;
    double time_taken = ((double)t)/CLOCKS_PER_SEC; // in seconds
 
    cout<<"prims() took "<<time_taken<<" seconds to execute \n";
    cout<<sum<<endl;
}

